#/bin/bash -l


ALAN_INIT_PATH=$(pwd)
ALAN_INIT_ALAN_PATH=alan
ALAN_INIT_BOOTLOADABLES_PATH=bootloadablesInit
ALAN_INIT_DB_PATH=dbInit
ALAN_INIT_NGINX_PATH=nginxInit
ALAN_INIT_ROUTINES_PATH=routinesInit
ALAN_INIT_SERVICES_PATH=servicesInit
ALAN_INIT_WEB_PATH=webInit



#Routines
echo "Start copy routines"

if [ ! -d  /root/bin ]
then
	mkdir -p /root/bin
	echo "created directory \"/root/bin\""
fi

cp ${ALAN_INIT_PATH}/${ALAN_INIT_ROUTINES_PATH}/* /root/bin/

echo "Copy routines finished"



#blink-red-processing start
pkill -f "sh /root/bin/blink-red-processing.sh"
sh /root/bin/blink-red-processing.sh &

echo "blink-red-processing started"



#Datenbank Log-Dateien löschen
echo "Start remove db log files"

if [ -e /var/lib/mysql/mysql-bin.index ]
then
	systemctl stop mysqld

	rm /var/lib/mysql/mysql-bin.*

	if [ -e /var/lib/mysql/alan.pid ]
	then
		rm /var/lib/mysql/alan.pid
		rm /var/lib/mysql/alan.err
	fi

	systemctl start mysqld
else
	echo "--> Nothing to remove"
fi

echo "Remove db log files finished"



#Datenbank
echo "Start db init"

mysql -u alan -p6xAV5TnZJZjvCry8 alandbUser < ${ALAN_INIT_PATH}/${ALAN_INIT_DB_PATH}/initial_db.sql
cp ${ALAN_INIT_PATH}/${ALAN_INIT_DB_PATH}/initial_db.sql /root/bin/

echo "DB init finished"



#Webseite
echo "Start copy website"

rm -r /usr/share/nginx/html/*
cp -r ${ALAN_INIT_PATH}/${ALAN_INIT_WEB_PATH}/* /usr/share/nginx/html/
chmod 755 -R /usr/share/nginx/html/*

if [ ! -d  /usr/share/nginx/html/uploads ]
then
	mkdir -p /usr/share/nginx/html/uploads
	echo "created directory \"/usr/share/nginx/html/uploads\""
fi

chmod 777 -R /usr/share/nginx/html/uploads

echo "Copy website finished"


#Services:
#echo "Start copy services"
#
#cp -r ${ALAN_INIT_PATH}/${ALAN_INIT_SERVICES_PATH}/* /etc/systemd/system/
#
#echo "Copy services finished"



#Serial number
#echo "Start copy serial number file"
#
#cp ${ALAN_INIT_PATH}/serial.ser /usr/local/share/
#
#echo "Copy serial number file finished"



#coredump
echo "Start delete coredumps and copy coredump.conf"

rm -f /var/lib/systemd/coredump/*
cp ${ALAN_INIT_PATH}/${ALAN_INIT_NGINX_PATH}/coredump.conf /etc/systemd/

echo "Delete coredumps and copy coredump.conf finished"



#nginx, php.ini
echo "Start copy nginx.conf, php.ini"

cp ${ALAN_INIT_PATH}/${ALAN_INIT_NGINX_PATH}/nginx.conf /etc/nginx/
cp ${ALAN_INIT_PATH}/${ALAN_INIT_NGINX_PATH}/php.ini /etc/php/

echo "Copy nginx.conf, php.ini finished"



#bootloadables
echo "Start copy bootloadables"

if [ ! -d  /alan ]
then
	mkdir -p /alan
	echo "created directory \"/alan\""
fi

rm /alan/*
cp ${ALAN_INIT_PATH}/${ALAN_INIT_BOOTLOADABLES_PATH}/* /alan/

echo "Copy bootloadables finished"



#ALAN
echo "Start copy ALAN"

if [ ! -d /usr/local/bin ]
then
	mkdir -p /usr/local/bin
	echo "created directory \"/usr/local/bin\""
fi

if [ ! -d /usr/local/lib ]
then
	mkdir -p /usr/local/lib
	echo "created directory \"/usr/local/lib\""
fi

cp ${ALAN_INIT_PATH}/${ALAN_INIT_ALAN_PATH}/ALANdeb /usr/local/bin/
cp ${ALAN_INIT_PATH}/${ALAN_INIT_ALAN_PATH}/lib* /usr/local/lib/

echo "Copy ALAN finished"



#blink-red-processing finished
pkill -f "sh /root/bin/blink-red-processing.sh"

echo "blink-red-processing finished"
