#!/bin/bash


source /root/bin/alanserviceparameters

if [ -e ${ALAN_BACKUP_PARAMETER_FILE} ]
then
	source ${ALAN_BACKUP_PARAMETER_FILE}

	if [ ! -z "${ALAN_BACKUP_TARGET}/${ALAN_BACKUP_FILENAME}" ]
	then
		if [ ! -e ${ALAN_RESTORE_PARAMETER_FILE} ]
		then
			systemctl stop ALAN
			mysqldump \
				--routines \
				--add-drop-database \
				--complete-insert \
				--extended-insert \
				-B \
				-u alan \
				-p6xAV5TnZJZjvCry8 alandbSystem alandbUser \
				> "${ALAN_BACKUP_TARGET}/ALAN_${ALAN_BACKUP_FILENAME}.bak"
			systemctl restart ALAN

			if [ -e ${ALAN_BACKUP_ERROR_FILE} ]
			then
				rm ${ALAN_BACKUP_ERROR_FILE}
			fi

			if [ -e ${ALAN_BACKUP_PARAMETER_FILE} ]
			then
				rm ${ALAN_BACKUP_PARAMETER_FILE}
			fi

			echo "success"
		else
			echo "restore is running $(date +%F-%T)" >> ${ALAN_BACKUP_ERROR_FILE}
		fi
	else
		echo "no filename given $(date +%F-%T)" >> ${ALAN_BACKUP_ERROR_FILE}
	fi
else
	echo "no parameters given $(date +%F-%T)" >> ${ALAN_BACKUP_ERROR_FILE}
fi
