#!/bin/bash


source /root/bin/alanserviceparameters

if [ -z $(mount | grep /mnt/sdcard | awk '{print $1}') ]
then
	exit 2
fi

ALAN_BACKUP_FILENAME="$1"
ALAN_BACKUP_TARGET="${ALAN_BACKUP_AND_RESTORE_FOLDER}"
ALAN_BACKUP_TARGET_FILENAME="${ALAN_BACKUP_TARGET}/${ALAN_BACKUP_FILENAME}.tmp"

echo "${ALAN_BACKUP_TARGET}"

if [ ! -e ${ALAN_RESTORE_PARAMETER_FILE} ]
then
	if [ ! -z "${ALAN_BACKUP_FILENAME}" ]
	then
		touch "${ALAN_BACKUP_TARGET_FILENAME}"

		if [ -e "${ALAN_BACKUP_TARGET_FILENAME}" ]
		then
			rm "${ALAN_BACKUP_TARGET_FILENAME}"
			echo "export ALAN_BACKUP_TARGET=\"${ALAN_BACKUP_TARGET}\"" > ${ALAN_BACKUP_PARAMETER_FILE}
			echo "export ALAN_BACKUP_FILENAME=\"${ALAN_BACKUP_FILENAME}\"" >> ${ALAN_BACKUP_PARAMETER_FILE}
			systemctl start ALANbackup
		else
			echo "invalid filename $(date +%F-%T)" >> ${ALAN_BACKUP_ERROR_FILE}
			exit 3
		fi

	else
		echo "backup failed: no filename given $(date +%F-%T)" >> ${ALAN_BACKUP_ERROR_FILE}
		exit 3
	fi
else
		echo "backup failed: Restore is running $(date +%F-%T)" >> ${ALAN_BACKUP_ERROR_FILE}
		exit 4
fi
