#!/bin/bash


source /root/bin/alanserviceparameters

if [ -z $(mount | grep /mnt/sdcard | awk '{print $1}') ]
then
	exit 2
fi

ALAN_RESTORE_FILENAME="$1"
ALAN_DATABASE_ID=$2
ALAN_RESTORE_SOURCE="${ALAN_BACKUP_AND_RESTORE_FOLDER}"

if [ ! -e ${ALAN_BACKUP_PARAMETER_FILE} ]
then
	if [ ! -z "${ALAN_RESTORE_FILENAME}" ]
	then
		if [ -e "${ALAN_RESTORE_SOURCE}/${ALAN_RESTORE_FILENAME}" ]
		then
			OTHER_DATABASE_ID=$(grep 'SELECT .* INTO databaseId;' "${ALAN_RESTORE_SOURCE}/${ALAN_RESTORE_FILENAME}" | awk '{print $2}')

			if [ ! -z ${OTHER_DATABASE_ID} ]
			then
				if [ ! ${ALAN_DATABASE_ID} -eq ${OTHER_DATABASE_ID} ]
				then
					echo "error!!"
					exit 1
				fi
			else
				echo "error!!"
				exit 1
			fi

			echo "export ALAN_RESTORE_SOURCE=\"${ALAN_RESTORE_SOURCE}\"" > ${ALAN_RESTORE_PARAMETER_FILE}
			echo "export ALAN_RESTORE_FILENAME=\"${ALAN_RESTORE_FILENAME}\"" >> ${ALAN_RESTORE_PARAMETER_FILE}
			systemctl start ALANrestore
		else
			echo "restore failed: file ${ALAN_RESTORE_SOURCE}/${ALAN_RESTORE_FILENAME} does not exist $(date +%F-%T)" >> ${ALAN_RESTORE_ERROR_FILE}
			exit 4
		fi

	else
		echo "restore failed: no filename given $(date +%F-%T)" >> ${ALAN_RESTORE_ERROR_FILE}
		exit 4
	fi
else
	echo "error!!!"
	echo "restore failed: backup is running $(date +%F-%T)" >> ${ALAN_RESTORE_ERROR_FILE}
	exit 5
fi
