#!/bin/bash


source /root/bin/alanserviceparameters

ALAN_UPDATE_FILENAME="$1"

echo "${ALAN_UPDATE_FILENAME}"

ALAN_UPDATE_TEMP_FOLDER=/tmp/alanupdate

if [ ! -z "${ALAN_UPDATE_FILENAME}" ]
then
	if [ -e "${ALAN_UPDATE_FILENAME}" ]
	then
		if [ -e ${ALAN_UPDATE_TEMP_FOLDER} ]
		then
			rm -rf ${ALAN_UPDATE_TEMP_FOLDER}
		fi

		mkdir -p ${ALAN_UPDATE_TEMP_FOLDER}

		if [ -d ${ALAN_UPDATE_TEMP_FOLDER} ]
		then
			cd ${ALAN_UPDATE_TEMP_FOLDER}

			if tar xf "${ALAN_UPDATE_FILENAME}"
			then
				if [ -e ./alanInitBrain/ ]
				then
					cd alanInitBrain

					if [ -e alanUpdateBrain.sh ]
					then
						echo "export ALAN_UPDATE_SCRIPT=\"${ALAN_UPDATE_TEMP_FOLDER}/alanInitBrain/alanUpdateBrain.sh\"" >> ${ALAN_UPDATE_PARAMETER_FILE}
						systemctl start ALANupdate
					else
						echo "update file does not contain executable"
						exit 7
					fi
				else
					echo "wrong update file"
					exit 6
				fi
			else
				echo "corrupted archive"
				exit 7
			fi
		else
				echo "wrong filesystem"
				exit 5
		fi
	else
			echo "restore failed: file ${ALANUPDATESOURCE}/${ALAN_UPDATE_FILENAME} does not exist $(date +%F-%T)" >> ${ALAN_UPDATE_ERROR_FILE}
			exit 4
	fi
else
	echo "restore failed: no filename given $(date +%F-%T)" >> ${ALAN_UPDATE_ERROR_FILE}
	exit 3
fi
