#!/bin/bash
#


export R_PATH=/mnt/sdcard
export RESCUE_FILENAME=ALAN_rescue_1090
export R_LOGNAME=alan_rescue_log.txt

export RESCUE_FILE=${R_PATH}/${RESCUE_FILENAME}
export R_LOG=${R_PATH}/${R_LOGNAME}



alan_rescue_restore(){
	if [ -z $1 ]
	then
		echo "alan_rescue_restore: no parameter"
		exit
	fi

	echo "restore"
	echo "Starting database restore from file ${R_PATH}/$1 to local database"
	systemctl stop ALAN
	sh /root/bin/blink-red-processing.sh &
	mysql -u alan -p6xAV5TnZJZjvCry8 alandbUser < ${R_PATH}/$1

	if [ -e /root/bin/initial_db.sql ]
	then
		echo "Initialize DB start"
		mysql -u alan -p6xAV5TnZJZjvCry8 < /root/bin/initial_db.sql
		echo "Initialize DB end"
	else
		echo "initial_db.sql nicht vorhanden"
	fi

	pkill -f 'sh /root/bin/blink-red-processing.sh'
	sh /root/bin/blink-start.sh
	systemctl start ALAN
	echo "Finished database restore"
	echo ""
	echo ""
}


alan_rescue_backup(){
	if [ -z $1 ]
	then
		echo "alan_rescue_backup: no parameter"
		exit
	fi

	echo "backup"
	echo "Starting database backup from local database to file ${R_PATH}/$1"
	sh /root/bin/blink-red-processing.sh &
	systemctl stop ALAN
	mysqldump --routines --add-drop-database --complete-insert --extended-insert -B -u alan -p6xAV5TnZJZjvCry8 alandbSystem alandbUser > ${R_PATH}/$1
	pkill -f 'sh /root/bin/blink-red-processing.sh'
	sh /root/bin/blink-start.sh
	systemctl start ALAN
	echo "Finished database backup"
	echo ""
	echo ""
}


alan_rescue_replacedb(){
	if [ -z $1 ]
	then
		echo "alan_rescue_replacedb: no parameter"
		exit
	fi

	if [ ! -d /var/lib/mysql/ ]
	then
		echo "alan_rescue_replacedb: path /var/lib/mysql does not exist"
		exit
	fi

	echo "replacedb"
	echo "Starting replace complete database filesystem from file ${R_PATH}/$1"
	sh /root/bin/blink-red-processing.sh &
	systemctl stop ALAN
	systemctl stop mysqld
	rm -r /var/lib/mysql/*
	cd /
	tar xzvf ${R_PATH}/$1
	systemctl start mysqld

	if [ -e /root/bin/initial_db.sql ]
	then
		echo "Initialize DB start"
		mysql -u alan -p6xAV5TnZJZjvCry8 < /root/bin/initial_db.sql
		echo "Initialize DB end"
	else
		echo "initial_db.sql nicht vorhanden"
	fi

	pkill -f 'sh /root/bin/blink-red-processing.sh'
	sh /root/bin/blink-start.sh
	systemctl start ALAN
	echo "Finished replace complete database"
	echo ""
	echo ""
}


alan_rescue_backupfulldb(){
	if [ -z $1 ]
	then
		echo "alan_rescue_backupfulldb: no parameter"
		exit
	fi

	if [ ! -d /var/lib/mysql/ ]
	then
		echo "alan_rescue_backupfulldb: path /var/lib/mysql does not exist"
		exit
	fi

	echo "backupfulldb"
	echo "Starting backup of complete database filesystem to file ${R_PATH}/$1"
	sh /root/bin/blink-red-processing.sh &
	systemctl stop ALAN
	systemctl stop mysqld
	cd /
	tar czvf ${R_PATH}/$1 /var/lib/mysql/
	systemctl start mysqld
	pkill -f 'sh /root/bin/blink-red-processing.sh'
	sh /root/bin/blink-start.sh
	systemctl start ALAN
	echo "Finished backupcomplete database"
	echo ""
	echo ""
}



export -f alan_rescue_backup
export -f alan_rescue_restore
export -f alan_rescue_replacedb
export -f alan_rescue_backupfulldb

if [ -e /dev/mmcblk1 ]
then
	if [ -e /dev/mmcblk0p1 ]
	then
		if [ ! -e /mnt/sdcard ]
		then
			mkdir -p /mnt/sdcard
		fi

		umount /mnt/sdcard/
		mount -o utf8 /dev/mmcblk0p1 /mnt/sdcard/

		if [ -e ${RESCUE_FILE} ]
		then
			echo "${RESCUE_FILENAME} exists" > ${R_LOG}
			echo "" >> ${R_LOG}
			awk	'{
				if($1=="backup")
				{
					system("bash -c '\''alan_rescue_backup "$2"'\''");
				}
				else if ($1=="restore")
				{
					system("bash -c '\''alan_rescue_restore "$2"'\''");
				}
				else if ($1=="replacedb")
				{
					system("bash -c '\''alan_rescue_replacedb "$2"'\''");
				}
				else if ($1=="backupfulldb")
				{
					system("bash -c '\''alan_rescue_backupfulldb "$2"'\''");
				}
			}' ${RESCUE_FILE} >> ${R_LOG} 2>&1
			mv ${RESCUE_FILE} ${RESCUE_FILE}.done
		fi

		echo "/dev/mmcblk0p1 mounted on /mnt/sdcard/"
	else
		if [ -e /mnt/sdcard ]
		then
			umount /mnt/sdcard
			rm -rf /mnt/sdcard
		fi
	fi
else
	if [ -e /mnt/sdcard ]
	then
		umount /mnt/sdcard
		rm -rf /mnt/sdcard
	fi
fi
